---
title: Firefox 51 for developers
slug: Mozilla/Firefox/Releases/51
tags:
  - Firefox
  - Mozilla
  - Release Notes
---
<div>{{FirefoxSidebar}}</div><p><a href="https://www.mozilla.org/firefox/developer/" style="float: right; margin-bottom: 20px; padding: 10px; text-align: center; border-radius: 4px; display: inline-block; background-color: #81BC2E; white-space: nowrap; color: white; text-shadow: 0px 1px 0px rgba(0, 0, 0, 0.25); box-shadow: 0px 1px 0px 0px rgba(0, 0, 0, 0.2), 0px -1px 0px 0px rgba(0, 0, 0, 0.3) inset;">To test the latest developer features of Firefox,<br>
 install Firefox Developer Edition</a>Firefox 51 was released on January 24, 2017. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="HTML">HTML</h3>

<ul>
 <li>{{HTMLElement("hr")}} elements can now be used as separators in {{HTMLElement("menu")}} elements ({{bug(870388)}}).</li>
 <li>The {{HTMLElement("input")}} and {{HTMLElement("textarea")}} elements' <code>selectionStart</code> and <code>selectionEnd</code> attributes now correctly return the current position of the text input cursor when there's no selection, instead of returning 0 ({{bug(1287655)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Implemented {{cssxref(":indeterminate")}} for &lt;input type="radio"&gt; ({{bug(885359)}}).</li>
 <li>Implemented {{cssxref(":placeholder-shown")}} for <code>&lt;input type="text"&gt;</code> ({{bug(1069015)}}).</li>
 <li>The {{cssxref("::placeholder")}} pseudo-element is now unprefixed ({{bug(1069012)}}).</li>
 <li>Fixed the {{cssxref(":valid")}} CSS pseudo-class which didn't match valid {{HTMLElement("form")}} elements ({{bug(1285425)}}).</li>
 <li>The <code>plaintext</code> value of {{cssxref("unicode-bidi")}} now also works with vertical writing modes ({{bug(1302734)}}).</li>
 <li>The <code>fill-box</code> and <code>stroke-box</code> values of {{cssxref("clip-path")}} are now properly supported; previously, they were aliases of <code>border-box</code> ({{bug(1289011)}}).</li>
 <li>Clamp flex line's height (clamping stretched flex items), in single-line auto-height flex container w/ max-height (spec change) ({{bug(1000957)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The ES2015 {{jsxref("Symbol.toStringTag")}} property has been implemented ({{bug(1114580)}}).</li>
 <li>The ES2015 {{jsxref("TypedArray.prototype.toString()")}} and {{jsxref("TypedArray.prototype.toLocaleString()")}} methods have been implemented ({{bug(1121938)}}).</li>
 <li>The {{jsxref("DateTimeFormat.prototype.formatToParts()")}} method is now available ({{bug(1289340)}}).</li>
 <li>{{jsxref("Statements/const", "const")}} and {{jsxref("Statements/let", "let")}} are now fully ES2015-compliant ({{bug(950547)}}).</li>
 <li>Using {{jsxref("Statements/const", "const")}} in <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a></code> loops now has a fresh binding for each iteration and no longer throws a {{jsxref("SyntaxError")}} ({{bug(1101653)}}).</li>
 <li>The deprecated <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for_each...in">for each...in</a> loop now presents a <a href="/en-US/docs/Web/JavaScript/Reference/Errors/For-each-in_loops_are_deprecated">warning in the console</a> ({{bug(1293205)}}). Please migrate your code to use the standardized <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a></code> loop.</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/function*">Generator functions</a> can't have a <a href="/en-US/docs/Web/JavaScript/Reference/Statements/label">label</a> anymore and "<code>let</code>" as a label name is disallowed now ({{bug(1288459)}}).</li>
 <li>Deprecated <a href="/en-US/docs/Web/JavaScript/Reference/Statements/Legacy_generator_function">legacy generator functions</a> will now throw when used in <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Method_definitions">method definitions</a> ({{bug(1199296)}}).</li>
 <li>The <code>next()</code> method of the <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols#The_iterator_protocol">iterator protocol</a> will now throw a {{jsxref("TypeError")}} if the returned value is not an object ({{bug(1016936)}}).</li>
 <li>Child-indexed pseudo-class selectors should match without a parent ({{bug(1300374)}}).</li>
</ul>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li><a href="/en-US/docs/Tools/Network_Monitor#Timings">Network Monitor now shows a "Blocked" state for network requests.</a></li>
 <li><a class="external external-icon" href="https://bugzilla.mozilla.org/buglist.cgi?list_id=13263768&amp;resolution=FIXED&amp;classification=Client%20Software&amp;chfieldto=2016-09-19&amp;query_format=advanced&amp;chfield=resolution&amp;chfieldfrom=2016-08-01&amp;chfieldvalue=FIXED&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;component=Developer%20Tools&amp;component=Developer%20Tools%3A%20about%3Adebugging&amp;component=Developer%20Tools%3A%20Animation%20Inspector&amp;component=Developer%20Tools%3A%20Canvas%20Debugger&amp;component=Developer%20Tools%3A%20Computed%20Styles%20Inspector&amp;component=Developer%20Tools%3A%20Console&amp;component=Developer%20Tools%3A%20CSS%20Rules%20Inspector&amp;component=Developer%20Tools%3A%20Debugger&amp;component=Developer%20Tools%3A%20DOM&amp;component=Developer%20Tools%3A%20Font%20Inspector&amp;component=Developer%20Tools%3A%20Framework&amp;component=Developer%20Tools%3A%20Graphic%20Commandline%20and%20Toolbar&amp;component=Developer%20Tools%3A%20Inspector&amp;component=Developer%20Tools%3A%20JSON%20Viewer&amp;component=Developer%20Tools%3A%20Memory&amp;component=Developer%20Tools%3A%20Netmonitor&amp;component=Developer%20Tools%3A%20Object%20Inspector&amp;component=Developer%20Tools%3A%20Performance%20Tools%20%28Profiler%2FTimeline%29&amp;component=Developer%20Tools%3A%20Responsive%20Design%20Mode&amp;component=Developer%20Tools%3A%20Scratchpad&amp;component=Developer%20Tools%3A%20Shared%20Components&amp;component=Developer%20Tools%3A%20Source%20Editor&amp;component=Developer%20Tools%3A%20Storage%20Inspector&amp;component=Developer%20Tools%3A%20Style%20Editor&amp;component=Developer%20Tools%3A%20User%20Stories&amp;component=Developer%20Tools%3A%20Web%20Audio%20Editor&amp;component=Developer%20Tools%3A%20WebGL%20Shader%20Editor&amp;component=Developer%20Tools%3A%20WebIDE&amp;product=Firefox">All devtools bugs fixed between Firefox 50 and Firefox 51</a>.</li>
</ul>

<h3 id="WebGL">WebGL</h3>

<ul>
 <li><a href="/en-US/docs/Web/API/WebGL_API">WebGL 2</a> is now enabled by default. See <a href="http://webglsamples.org/WebGL2Samples/">webglsamples.org/WebGL2Samples</a> for a few demos.

  <ul>
   <li>WebGL 2 provides the {{domxref("WebGL2RenderingContext")}} interface that brings OpenGL ES 3.0 to the {{HTMLElement("canvas")}} element.</li>
   <li>New features include:
    <ul>
     <li><a href="/en-US/docs/Web/API/WebGL2RenderingContext/texImage3D">3D textures</a>,</li>
     <li><a href="/en-US/docs/Web/API/WebGLSampler">Sampler objects</a>,</li>
     <li><a href="/en-US/docs/Web/API/WebGL2RenderingContext#Uniform_buffer_objects">Uniform Buffer objects</a>,</li>
     <li><a href="/en-US/docs/Web/API/WebGLSync">Sync objects</a>,</li>
     <li><a href="/en-US/docs/Web/API/WebGLQuery">Query objects</a>,</li>
     <li><a href="/en-US/docs/Web/API/WebGLTransformFeedback">Tranform Feedback objects</a>,</li>
     <li>Promoted extensions that are now core to WebGL 2: <a href="/en-US/docs/Web/API/WebGLVertexArrayObject">Vertex Array objects</a>, <a href="/en-US/docs/Web/API/WebGL2RenderingContext/drawArraysInstanced">instancing</a>, <a href="/en-US/docs/Web/API/WebGL2RenderingContext/drawBuffers">multiple render targets</a>, <a href="/en-US/docs/Web/API/EXT_frag_depth">fragment depth</a>.</li>
    </ul>
   </li>
  </ul>
 </li>
 <li>The <code>WEBGL_compressed_texture_es3</code> extension (implemented in Firefox 46) has been renamed to {{domxref("WEBGL_compressed_texture_etc")}} ({{bug(1316778)}}) and is no longer included by default in WebGL 2 contexts ({{bug(1306174)}}).</li>
 <li>The {{domxref("EXT_disjoint_timer_query")}} extension has been updated to use {{domxref("WebGLQuery")}} objects instead of <code>WebGLTimerQuery</code> objects ({{bug(1308057)}}).</li>
 <li>The {{domxref("OES_vertex_array_object")}} extension now uses the WebGL 2 {{domxref("WebGLVertexArrayObject")}} object instead of its own <code>WebGLVertexArrayObjectOES</code> object ({{bug(1318523)}}).</li>
 <li>You can now use {{domxref("ImageBitmap")}} objects as a sources for texture images in methods like {{domxref("WebGLRenderingContext.texImage2D()")}}, {{domxref("WebGLRenderingContext.texSubImage2D()")}}, {{domxref("WebGL2RenderingContext.texImage3D()")}}, or {{domxref("WebGL2RenderingContext.texSubImage3D()")}} ({{bug(1324924)}}).</li>
</ul>

<h3 id="IndexedDB_v2">IndexedDB v2</h3>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a> version 2 implementation is now complete:

  <ul>
   <li>Supports for the new {{domxref("IDBObjectStore.getKey()")}} method has been added ({{bug(1271506)}}).</li>
   <li>Supports for {{domxref("IDBCursor.continuePrimaryKey()")}} method has been added ({{bug(1271505)}}).</li>
   <li>Binary keys are now supported ({{bug(1271500)}}).</li>
   <li>See also <a href="https://hacks.mozilla.org/2016/10/whats-new-in-indexeddb-2-0/">"What’s new in IndexedDB 2.0?" – Mozilla hacks</a></li>
  </ul>
 </li>
</ul>

<h3 id="Canvas">Canvas</h3>

<ul>
 <li>The non-standard <code>CanvasRenderingContext2D.mozFillRule</code>() method has been removed; the fill rule can be defined using a parameter of the standard {{domxref("CanvasRenderingContext2D.fill()")}} method ({{bug(826619)}}).</li>
 <li>The {{domxref("CanvasRenderingContext2D.imageSmoothingEnabled")}} has been unprefixed ({{bug(768072)}})</li>
</ul>

<h3 id="SVG">SVG</h3>

<ul>
 <li>Added {{SVGAttr("tabindex")}} attribute ({{bug(778654)}}).</li>
 <li>Added {{SVGAttr("href")}} attribute, which renders {{SVGAttr("xlink:href")}} obsolete ({{bug(1245751)}}).</li>
 <li>You can now use custom data attributes on SVG elements through the {{domxref("SVGElement.dataset")}} property and the {{SVGAttr("data-*")}} set of SVG attributes ({{bug(921834)}}).</li>
 <li>CSS Animations used in an SVG image which is presented in an {{HTMLElement("img")}} element now work again; this was an old regression ({{bug(1190881)}}).</li>
</ul>

<h3 id="Web_Workers">Web Workers</h3>

<ul>
 <li>The non-standard and obsolete {{domxref("WorkerGlobalScope.onclose")}} event handler and {{domxref("Worker")}} use of the {{event("close")}} event have been removed from Firefox.</li>
</ul>

<h3 id="Networking">Networking</h3>

<ul>
 <li>Scripts served with an <code>image/*</code>, <code>video/*</code>, <code>audio/*</code> or <code>text/csv</code> MIME type are now blocked and are not loaded or executed. This happen when they are declared using {{HTMLElement("script")}}, or loaded via {{domxref("Worker.importScripts()")}}, {{domxref("Worker.Worker","Worker()")}}, {{domxref("SharedWorker.SharedWorker", "SharedWorker()")}} ({{bug(1229267)}} and {{bug(1288361)}}).</li>
 <li>Support for SHA-1 certificates from publicly-trusted certificate authorities has been removed ({{bug(1302140)}}). See also <a href="https://blog.mozilla.org/security/2016/10/18/phasing-out-sha-1-on-the-public-web/">Phasing Out SHA-1 on the Public Web</a> for more information.</li>
 <li>New WoSign and StartCom certificates will no longer be accepted ({{bug(1309707)}}), see <a href="https://blog.mozilla.org/security/2016/10/24/distrusting-new-wosign-and-startcom-certificates/">Distrusting New WoSign and StartCom Certificates</a> for more information.</li>
 <li>
  <p>The <a href="/en-US/docs/Mozilla/Projects/Necko/Proxy_Auto-Configuration_(PAC)_file">PAC</a> <code>FindProxyForURL(url, host)</code> function now strips paths and queries from https:// URLs to avoid information leakage (see {{bug(1255474)}}, <a href="https://www.contextis.com/resources/blog/leaking-https-urls-20-year-old-vulnerability/">Sniffing HTTPS URLS with malicious PAC files</a>, or <code>CVE-2017-5384</code>).</p>
 </li>
</ul>

<h3 id="XHR">XHR</h3>

<ul>
 <li>The {{domxref("XMLHttpRequest.responseXML")}} property no longer returns a partial {{domxref("Document")}} with a &lt;parsererror&gt; node placed at the top when a parse error occurs attempting to interpret the received data. Instead, it correctly returns <code>null</code> ({{bug(289714)}}).</li>
 <li>To match the latest specification an {{domxref("XMLHttpRequest")}} without an {{HTTPHeader("Accept")}} header set with {{domxref("XMLHttpRequest.setRequestHeader()", "setRequestHeader()")}} is now sent with such a header, with its value set to <code>*/*</code> ({{bug(918752)}}).</li>
 <li>Fixed {{domxref("XMLHttpRequest.open()")}} so that, when omitted, the <code>username</code> and <code>password</code> parameters now default to <code>null</code>, per the specification ({{bug(933759)}}).</li>
</ul>

<h3 id="WebRTC">WebRTC</h3>

<ul>
 <li>The {{domxref("RTCPeerConnection.removeStream()")}} method has been removed. It was deprecated back in Firefox 22, and has been throwing a <code>NotSupportedError</code> for a long time. You need to use {{domxref("RTCPeerConnection.removeTrack()")}} instead, for each track on the stream.</li>
 <li>WebRTC now supports the VP9 codec by default. When added in Firefox 46, VP9 was disabled by default, but when enabled was the preferred codec; however, it has been moved to be the second choice (after VP8) due to its current level of CPU usage.</li>
 <li>The method {{domxref("HTMLMediaElement.captureStream()")}}, which returns a {{domxref("MediaStream")}} containing the content of the specified {{HTMLElement("video")}} or {{HTMLElement("audio")}}. It's worth noting that this is prefixed still as <code>mozCaptureStream()</code>, and that it doesn't yet exactly match the spec.</li>
</ul>

<h3 id="Audiovideo">Audio/video</h3>

<ul>
 <li>Added FLAC support (<a href="https://xiph.org/flac/index.html">FLAC codec</a>) in both FLAC and Ogg containers ({{bug(1195723)}}). Supported FLAC MIME types are: <code>audio/flac</code> and <code>audio/x-flac</code>. For FLAC in Ogg, supported MIME types are: <code>audio/ogg; codecs=flac</code>, and <code>video/ogg; codecs=flac</code>.</li>
 <li>Added support for FLAC in MP4 (both with and without MSE) ({{bug(1303888)}}).</li>
 <li>Throttling in background tabs of timers created by {{domxref("WindowTimers.setInterval", "Window.setInterval()")}} and {{domxref("WindowTimers.setTimeout", "Window.setTimeout()")}} was changed in Firefox 50 to no longer occur if a <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a> {{domxref("AudioContext")}} is actively playing sound. However, this didn't resolve all scenarios in which timing-sensitive audio playback (such as music players generating individual notes using timers) could fail to work properly. For that reason, Firefox 51 no longer throttles background tabs which have an {{domxref("AudioContext")}}, even if it's not currently playing sound.</li>
</ul>

<h3 id="DOM">DOM</h3>

<ul>
 <li>The {{domxref("DOMImplementation.hasFeature()")}} now returns <code>true</code> in all cases ({{bug(984778)}}).</li>
 <li>The {{domxref("HTMLInputElement")}} and {{domxref("HTMLTextAreaElement")}} properties <code>selectionStart</code> and <code>selectionEnd</code> now correctly return the current position of the text input cursor when there's no selection, instead of returning 0 ({{bug(1287655)}}).</li>
 <li>The {{domxref("HTMLImageElement")}} interface and the corresponding {{HTMLElement("img")}} element now support the {{htmlattrxref("onerror")}} event handler, sending {{event("error")}} events to the element whenever <a href="/en-US/docs/Web/API/HTMLImageElement#Errors">errors occur attempting to load or interpret images</a>.</li>
 <li>You can now change a Web {{domxref("Animation")}}'s effect by setting the value of its {{domxref("Animation.effect", "effect")}} property. Previously, this property was read-only ({{bug(1049975)}}).</li>
 <li>The Permissions API method {{domxref("Permissions.revoke()")}} has been put behind a preference (<code>dom.permissions.revoke.enable</code>) and disabled by default since its design and even its very existence is under discussion in the <a href="https://www.w3.org/2011/webappsec/">Web Application Security Working Group</a>.</li>
 <li>The <a href="/en-US/docs/Web/API/Storage_API">Storage API</a>'s {{domxref("NavigatorStorage.storage", "navigator.storage")}} property and {{domxref("StorageManager.estimate()")}} method have been implemented along with the needed supporting code. Storage unit persistence features are not yet implemented. See {{bug(1267941)}}.</li>
 <li>For privacy reasons, both {{domxref("BatteryManager.chargingTime")}} and {{domxref("BatteryManager.dischargingTime")}} now round the returned value to the closest 15 minutes ({{bug(1292655)}}).</li>
</ul>

<h3 id="Events">Events</h3>

<ul>
 <li>Firefox now supports the {{domxref("GlobalEventHandlers.onanimationstart", "onanimationstart")}}, {{domxref("GlobalEventHandlers.onanimationiteration", "onanimationiteration")}}, and {{domxref("GlobalEventHandlers.onanimationstart", "onanimationstart")}} event handlers, in addition to supporting the corresponding events using {{domxref("EventTarget.addEventListener", "addEventListener()")}} ({{bug(911987)}}).</li>
 <li>Firefox now supports the {{domxref("GlobalEventHandlers.ontransitionend", "ontransitionend")}} event handler ({{bug(911987)}}).</li>
</ul>

<h3 id="Security">Security</h3>

<ul>
 <li>When login pages (i.e those containing an <code><a href="/en-US/docs/Web/HTML/Element/input/password">&lt;input type="password"&gt;</a></code> field) are created so that they would be submitted insecurely, Firefox displays a crossed out lock icon in the address bar to warn users ({{bug(1319119)}}). See <a href="/en-US/docs/Web/Security/Insecure_passwords">Insecure passwords</a> for more details.</li>
</ul>

<h3 id="Removals">Removals</h3>

<ul>
 <li>The non-standard <a href="/en-US/docs/Archive/Firefox_OS/API/Simple_Push_API">Simple Push API</a>, mainly intended for use with Firefox OS and now superseded by the <a href="/en-US/docs/Web/API/Push_API">W3C Push API</a>, has been completely removed from Gecko ({{bug(1296579)}}).</li>
 <li>The non-standard <a href="/en-US/docs/Archive/Firefox_OS/API/Alarm_API">Alarms API</a>, mainly intended for use with Firefox OS, has been completely removed from Gecko ({{bug(1300884)}}).</li>
 <li>Support for prefixes in the <a href="/en-US/docs/Web/API/Page_Visibility_API">Page Visibility API</a> has been removed ({{bug(812701)}}).</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<ul>
 <li>New APIs:
  <ul>
   <li>{{WebExtAPIRef("idle.queryState()")}} ({{bug(1299846)}})</li>
   <li>{{WebExtAPIRef("idle.onStateChanged")}} ({{bug(1299775)}})</li>
   <li>{{WebExtAPIRef("management.getSelf()")}} ({{bug(1283116)}})</li>
   <li>{{WebExtAPIRef("management.uninstallSelf()")}} ({{bug(1220136)}})</li>
   <li>{{WebExtAPIRef("runtime.getBrowserInfo()")}} ({{bug(1268399)}})</li>
   <li>{{WebExtAPIRef("runtime.reload()")}} and {{WebExtAPIRef("runtime.onUpdateAvailable()")}} ({{bug(1279012)}})</li>
  </ul>
 </li>
 <li>You can now <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/Embedded_WebExtensions">embed a WebExtension in a legacy add-on type</a> ({{bug(1252215)}}).</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/Interact_with_the_clipboard">Clipboard access</a> is now supported ({{bug(1197451)}})</li>
 <li>The arguments passed to the callback of {{WebExtAPIRef("tabs.executeScript()")}} have been fixed ({{bug(1290157)}})</li>
 <li><a href="/en-US/docs/Web/API/Storage/LocalStorage">localStorage</a> is now cleared when a WebExtension is uninstalled ({{bug(1213990)}})</li>
 <li>A changed {{HTTPHeader("Content-Type")}} header in Web Extensions is now taken into account ({{bug(1304331)}})</li>
</ul>

<h3 id="Other">Other</h3>

<ul>
 <li>The <a href="/en-US/Add-ons/Install_Manifests#multiprocessCompatible"><code>multiprocessCompatible</code> property of <code>install.rdf</code></a> must now be explicitly set to <code>false</code> to prevent multiprocess from being enabled in Firefox when the add-on is installed.</li>
 <li>The Mozilla-specific <a href="/en-US/docs/Mozilla/Projects/Social_API">Social API</a> has been substantially changed (largely to remove APIs no longer used), as follows:
  <ul>
   <li>The {{domxref("MozSocial")}} interface and the {{domxref("navigator.mozSocial")}} property which supports it have been removed.</li>
   <li>The <a href="/en-US/docs/Mozilla/Projects/Social_API/Bookmarks">Social Bookmarks API</a> has been removed.</li>
   <li>The Social chat functionality has been removed.</li>
   <li>The Social Status API has been removed.</li>
   <li>All of the <a href="/en-US/docs/Mozilla/Projects/Social_API/Widgets">social widgets</a>, except for the Share panel, have been removed. This includes the social sidebar, flyover panels, and so forth.</li>
   <li>All supporting user interface features and functionality for the removed APIs have been removed as well.</li>
   <li><a href="/en-US/docs/Mozilla/Projects/Social_API/Manifest">Social service provider manifest</a> properties supporting the removed functionality are no longer supported.</li>
  </ul>
 </li>
 <li>If an add-on uses<code> mimeTypes.rdf</code> to provide a file extension to MIME type mapping, it must now register an entry in the <code>"ext-to-type-mapping"</code> category ({{bug(306471)}}).</li>
 <li>The <a href="/en-US/docs/Mozilla/Gecko/Chrome/API/Browser_API">Browser API</a> now includes a <code>detail</code> object on the event object of the <code><a href="/en-US/docs/Web/Events/mozbrowserlocationchange">mozbrowserlocationchange</a></code> event that contains <code>canGoForward</code>/<code>canGoBack</code> properties, allowing retrieval of the mozBrowser's back/forward status synchronously ({{bug(1279635)}}).</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/51">Site Compatibility for Firefox 51</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(50)}}</p>
